using System;
using System.Net;

namespace FelicaSimpleServer
{
	/// <summary>
	/// NCAg̏ԂێD
	/// </summary>
	public class ClientItem
	{
		public IPAddress ip;
		public int port;
		public int clientId;
		public long felicaId;
		public DateTime date;

		public bool isReady = false;
		const string Separator = ",";

		public ClientItem(IPAddress ip, int port, string line)
		{

			if(line == null) return;

			string [] data = line.Split(Separator.ToCharArray());
			if(data.Length != 3) return;

			int clientId = int.Parse(data[0]);
			long felicaId = long.Parse(data[1]);
			DateTime date;
			try
			{
				date = DateTime.Parse(data[2]);
			}
			catch(Exception ex)
			{
				Util.PrintMessage(ex.ToString());
				return;
			}
			
			this.ip = ip;
			this.port = port;
			this.clientId = clientId;
			this.felicaId = felicaId;
			this.date = date;

			this.isReady = true;
		}
		
		public ClientItem(IPAddress ip, int port, int clientId, int felicaId, DateTime date)
		{
			this.ip = ip;
			this.port = port;
			this.clientId = clientId;
			this.felicaId = felicaId;
			this.date = date;

			this.isReady = true;
		}

		public ClientItem(IPAddress ip, int port)
		{
			this.ip = ip;
			this.port = port;
			this.clientId = 0;
			this.felicaId = 0;
			this.date = DateTime.Now;

			this.isReady = false;
		}

	}
}
