using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Threading;
using System.IO;
using System.Net;
using System.Diagnostics;
using System.Text.RegularExpressions;

namespace FelicaSimpleServer
{
	/// <summary>
	/// FelicaReader Pasori̓eXgp̃tH[łD
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		#region ϐ
		
		Server server = null;

		//AvP[V̏
		private enum Modes{Init, Open};
		private Modes mode = Modes.Init;

		//ݒ̕ۑt@C
		string settingFileName = Application.StartupPath + @"\setting.txt";
	
		//bZ[Wێϐ
		string message = "";
		//Xe[^Xo[̃bZ[Wpϐ
		string statusMessage = "";
		
		//NCAgXg̃L[ACe
		enum ListViewSort {IpPort, Id};
		ListViewSort listViewSort;
		//NCAgXgɂؒfς݃NCAg̑
		enum ListViewRemove {Color, Del};
		ListViewRemove listViewRemove;

		//bZ[Wo͂~
		bool messageEnabled = true;
		//tO
		bool initialized = false;

		public bool MessageEnabled
		{
			get{return messageEnabled;}
		}
		public bool Initialized
		{
			get{return initialized;}
		}		
		#endregion

		#region RXgN^/fXgN^
		//RXgN^		
		public MainForm()
		{
			InitializeComponent();	
			Util.form = this;
			if(radioButtonSortId.Checked)
				listViewSort = ListViewSort.Id;
			else
				listViewSort = ListViewSort.IpPort;

			if(radioButtonRemoveColor.Checked)
				listViewRemove = ListViewRemove.Color;
			else
				listViewRemove = ListViewRemove.Del;

			InitServer();
			LoadSettings();
			
			ChangeComponentState(Modes.Init);
			
			initialized = true;

			return;
		}

		//㏈s
		protected override void Dispose( bool disposing )
		{
			SaveSettings();
			StopServer();

			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}
		#endregion

		#region GUIR|[lg̐錾
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonOpen;
		private System.Windows.Forms.Button buttonClose;
		private System.Windows.Forms.TabControl tabControl;
		private System.Windows.Forms.TabPage tabPageId;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.GroupBox groupBoxCommand;
		private System.Windows.Forms.TabPage tabPageOption;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.ColumnHeader columnHeaderIp;
		private System.Windows.Forms.ColumnHeader columnHeaderClient;
		private System.Windows.Forms.ColumnHeader columnHeaderFelica;
		private System.Windows.Forms.ColumnHeader columnHeaderDate;
		private System.Windows.Forms.ListView listViewClient;
		private System.Windows.Forms.GroupBox groupBoxSort;
		private System.Windows.Forms.RadioButton radioButtonSortId;
		private System.Windows.Forms.RadioButton radioButtonSortIp;
		private System.Windows.Forms.GroupBox groupBoxRemove;
		private System.Windows.Forms.RadioButton radioButtonRemoveDel;
		private System.Windows.Forms.RadioButton radioButtonRemoveColor;
		private System.Windows.Forms.CheckBox checkBoxMessage;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.Button buttonIp;
		private System.Windows.Forms.NumericUpDown numericUpDownPort;
		private System.Windows.Forms.Label labelPort;
		private System.Windows.Forms.Label labelIp;
		private System.Windows.Forms.TextBox textBoxIp;
		private System.Windows.Forms.GroupBox groupBoxServer;
		private System.Windows.Forms.GroupBox groupBoxDebug;

		
		#endregion

		#region GUIR|[lg̏
		private void InitializeComponent()
		{
			this.buttonOpen = new System.Windows.Forms.Button();
			this.buttonClose = new System.Windows.Forms.Button();
			this.tabControl = new System.Windows.Forms.TabControl();
			this.tabPageId = new System.Windows.Forms.TabPage();
			this.listViewClient = new System.Windows.Forms.ListView();
			this.columnHeaderIp = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderClient = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderFelica = new System.Windows.Forms.ColumnHeader();
			this.columnHeaderDate = new System.Windows.Forms.ColumnHeader();
			this.tabPageOption = new System.Windows.Forms.TabPage();
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.groupBoxCommand = new System.Windows.Forms.GroupBox();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.groupBoxSort = new System.Windows.Forms.GroupBox();
			this.radioButtonSortId = new System.Windows.Forms.RadioButton();
			this.radioButtonSortIp = new System.Windows.Forms.RadioButton();
			this.groupBoxRemove = new System.Windows.Forms.GroupBox();
			this.radioButtonRemoveDel = new System.Windows.Forms.RadioButton();
			this.radioButtonRemoveColor = new System.Windows.Forms.RadioButton();
			this.checkBoxMessage = new System.Windows.Forms.CheckBox();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.buttonIp = new System.Windows.Forms.Button();
			this.numericUpDownPort = new System.Windows.Forms.NumericUpDown();
			this.labelPort = new System.Windows.Forms.Label();
			this.labelIp = new System.Windows.Forms.Label();
			this.textBoxIp = new System.Windows.Forms.TextBox();
			this.groupBoxServer = new System.Windows.Forms.GroupBox();
			this.groupBoxDebug = new System.Windows.Forms.GroupBox();
			this.tabControl.SuspendLayout();
			this.tabPageId.SuspendLayout();
			this.tabPageOption.SuspendLayout();
			this.groupBoxCommand.SuspendLayout();
			this.groupBoxSort.SuspendLayout();
			this.groupBoxRemove.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).BeginInit();
			this.groupBoxServer.SuspendLayout();
			this.groupBoxDebug.SuspendLayout();
			this.SuspendLayout();
			// 
			// buttonOpen
			// 
			this.buttonOpen.Location = new System.Drawing.Point(8, 16);
			this.buttonOpen.Name = "buttonOpen";
			this.buttonOpen.TabIndex = 1;
			this.buttonOpen.Text = "Jn";
			this.buttonOpen.Click += new System.EventHandler(this.buttonOpen_Click);
			// 
			// buttonClose
			// 
			this.buttonClose.Enabled = false;
			this.buttonClose.Location = new System.Drawing.Point(104, 16);
			this.buttonClose.Name = "buttonClose";
			this.buttonClose.TabIndex = 2;
			this.buttonClose.Text = "~";
			this.buttonClose.Click += new System.EventHandler(this.buttonClose_Click);
			// 
			// tabControl
			// 
			this.tabControl.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.tabPageId,
																					 this.tabPageOption});
			this.tabControl.Location = new System.Drawing.Point(0, 56);
			this.tabControl.Name = "tabControl";
			this.tabControl.SelectedIndex = 0;
			this.tabControl.Size = new System.Drawing.Size(432, 280);
			this.tabControl.TabIndex = 8;
			// 
			// tabPageId
			// 
			this.tabPageId.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.listViewClient});
			this.tabPageId.Location = new System.Drawing.Point(4, 21);
			this.tabPageId.Name = "tabPageId";
			this.tabPageId.Size = new System.Drawing.Size(424, 255);
			this.tabPageId.TabIndex = 1;
			this.tabPageId.Text = "NCAg";
			// 
			// listViewClient
			// 
			this.listViewClient.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							 this.columnHeaderIp,
																							 this.columnHeaderClient,
																							 this.columnHeaderFelica,
																							 this.columnHeaderDate});
			this.listViewClient.GridLines = true;
			this.listViewClient.Location = new System.Drawing.Point(8, 16);
			this.listViewClient.Name = "listViewClient";
			this.listViewClient.Size = new System.Drawing.Size(392, 232);
			this.listViewClient.TabIndex = 21;
			this.listViewClient.View = System.Windows.Forms.View.Details;
			// 
			// columnHeaderIp
			// 
			this.columnHeaderIp.Text = "IP:Port";
			this.columnHeaderIp.Width = 100;
			// 
			// columnHeaderClient
			// 
			this.columnHeaderClient.Text = "Client";
			this.columnHeaderClient.Width = 46;
			// 
			// columnHeaderFelica
			// 
			this.columnHeaderFelica.Text = "Felica ID";
			this.columnHeaderFelica.Width = 120;
			// 
			// columnHeaderDate
			// 
			this.columnHeaderDate.Text = "Date";
			this.columnHeaderDate.Width = 120;
			// 
			// tabPageOption
			// 
			this.tabPageOption.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.groupBoxDebug,
																						this.groupBoxServer,
																						this.groupBoxSort,
																						this.groupBoxRemove});
			this.tabPageOption.Location = new System.Drawing.Point(4, 21);
			this.tabPageOption.Name = "tabPageOption";
			this.tabPageOption.Size = new System.Drawing.Size(424, 255);
			this.tabPageOption.TabIndex = 2;
			this.tabPageOption.Text = "IvV";
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 330);
			this.statusBar.Name = "statusBar";
			this.statusBar.Size = new System.Drawing.Size(426, 22);
			this.statusBar.SizingGrip = false;
			this.statusBar.TabIndex = 14;
			// 
			// groupBoxCommand
			// 
			this.groupBoxCommand.Controls.AddRange(new System.Windows.Forms.Control[] {
																						  this.buttonOpen,
																						  this.buttonClose});
			this.groupBoxCommand.Location = new System.Drawing.Point(8, 0);
			this.groupBoxCommand.Name = "groupBoxCommand";
			this.groupBoxCommand.Size = new System.Drawing.Size(192, 48);
			this.groupBoxCommand.TabIndex = 1;
			this.groupBoxCommand.TabStop = false;
			this.groupBoxCommand.Text = "R}h";
			// 
			// splitter1
			// 
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 330);
			this.splitter1.TabIndex = 15;
			this.splitter1.TabStop = false;
			// 
			// groupBoxSort
			// 
			this.groupBoxSort.Controls.AddRange(new System.Windows.Forms.Control[] {
																					   this.radioButtonSortId,
																					   this.radioButtonSortIp});
			this.groupBoxSort.Location = new System.Drawing.Point(8, 72);
			this.groupBoxSort.Name = "groupBoxSort";
			this.groupBoxSort.Size = new System.Drawing.Size(184, 40);
			this.groupBoxSort.TabIndex = 6;
			this.groupBoxSort.TabStop = false;
			this.groupBoxSort.Text = "NCAg̔";
			// 
			// radioButtonSortId
			// 
			this.radioButtonSortId.Location = new System.Drawing.Point(104, 16);
			this.radioButtonSortId.Name = "radioButtonSortId";
			this.radioButtonSortId.Size = new System.Drawing.Size(72, 16);
			this.radioButtonSortId.TabIndex = 5;
			this.radioButtonSortId.Text = "IDŔ";
			// 
			// radioButtonSortIp
			// 
			this.radioButtonSortIp.Checked = true;
			this.radioButtonSortIp.Location = new System.Drawing.Point(8, 16);
			this.radioButtonSortIp.Name = "radioButtonSortIp";
			this.radioButtonSortIp.Size = new System.Drawing.Size(104, 16);
			this.radioButtonSortIp.TabIndex = 4;
			this.radioButtonSortIp.TabStop = true;
			this.radioButtonSortIp.Text = "IP:PortŔ";
			this.radioButtonSortIp.CheckedChanged += new System.EventHandler(this.radioButtonSortIp_CheckedChanged);
			// 
			// groupBoxRemove
			// 
			this.groupBoxRemove.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.radioButtonRemoveDel,
																						 this.radioButtonRemoveColor});
			this.groupBoxRemove.Location = new System.Drawing.Point(200, 72);
			this.groupBoxRemove.Name = "groupBoxRemove";
			this.groupBoxRemove.Size = new System.Drawing.Size(208, 40);
			this.groupBoxRemove.TabIndex = 7;
			this.groupBoxRemove.TabStop = false;
			this.groupBoxRemove.Text = "ؒfꂽNCAg̕\";
			// 
			// radioButtonRemoveDel
			// 
			this.radioButtonRemoveDel.Location = new System.Drawing.Point(96, 16);
			this.radioButtonRemoveDel.Name = "radioButtonRemoveDel";
			this.radioButtonRemoveDel.Size = new System.Drawing.Size(96, 16);
			this.radioButtonRemoveDel.TabIndex = 5;
			this.radioButtonRemoveDel.Text = "Xg폜";
			// 
			// radioButtonRemoveColor
			// 
			this.radioButtonRemoveColor.Checked = true;
			this.radioButtonRemoveColor.Location = new System.Drawing.Point(8, 16);
			this.radioButtonRemoveColor.Name = "radioButtonRemoveColor";
			this.radioButtonRemoveColor.Size = new System.Drawing.Size(88, 16);
			this.radioButtonRemoveColor.TabIndex = 4;
			this.radioButtonRemoveColor.TabStop = true;
			this.radioButtonRemoveColor.Text = "DFŕ\";
			this.radioButtonRemoveColor.CheckedChanged += new System.EventHandler(this.radioButtonRemoveColor_CheckedChanged);
			// 
			// checkBoxMessage
			// 
			this.checkBoxMessage.Checked = true;
			this.checkBoxMessage.CheckState = System.Windows.Forms.CheckState.Checked;
			this.checkBoxMessage.Location = new System.Drawing.Point(8, 16);
			this.checkBoxMessage.Name = "checkBoxMessage";
			this.checkBoxMessage.Size = new System.Drawing.Size(136, 16);
			this.checkBoxMessage.TabIndex = 5;
			this.checkBoxMessage.Text = "bZ[W\";
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(24, 32);
			this.textBoxMessage.Multiline = true;
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBoxMessage.Size = new System.Drawing.Size(368, 88);
			this.textBoxMessage.TabIndex = 4;
			this.textBoxMessage.Text = "";
			// 
			// buttonIp
			// 
			this.buttonIp.Location = new System.Drawing.Point(152, 24);
			this.buttonIp.Name = "buttonIp";
			this.buttonIp.Size = new System.Drawing.Size(64, 23);
			this.buttonIp.TabIndex = 27;
			this.buttonIp.Text = "IP擾";
			// 
			// numericUpDownPort
			// 
			this.numericUpDownPort.Location = new System.Drawing.Point(296, 24);
			this.numericUpDownPort.Maximum = new System.Decimal(new int[] {
																			  100000,
																			  0,
																			  0,
																			  0});
			this.numericUpDownPort.Name = "numericUpDownPort";
			this.numericUpDownPort.Size = new System.Drawing.Size(56, 19);
			this.numericUpDownPort.TabIndex = 26;
			this.numericUpDownPort.Value = new System.Decimal(new int[] {
																			4321,
																			0,
																			0,
																			0});
			// 
			// labelPort
			// 
			this.labelPort.Location = new System.Drawing.Point(248, 24);
			this.labelPort.Name = "labelPort";
			this.labelPort.Size = new System.Drawing.Size(40, 16);
			this.labelPort.TabIndex = 25;
			this.labelPort.Text = "|[g:";
			// 
			// labelIp
			// 
			this.labelIp.Location = new System.Drawing.Point(8, 24);
			this.labelIp.Name = "labelIp";
			this.labelIp.Size = new System.Drawing.Size(32, 16);
			this.labelIp.TabIndex = 24;
			this.labelIp.Text = "IP:";
			// 
			// textBoxIp
			// 
			this.textBoxIp.Location = new System.Drawing.Point(48, 24);
			this.textBoxIp.Name = "textBoxIp";
			this.textBoxIp.Size = new System.Drawing.Size(88, 19);
			this.textBoxIp.TabIndex = 23;
			this.textBoxIp.Text = "127.0.0.1";
			// 
			// groupBoxServer
			// 
			this.groupBoxServer.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.buttonIp,
																						 this.numericUpDownPort,
																						 this.labelPort,
																						 this.labelIp,
																						 this.textBoxIp});
			this.groupBoxServer.Location = new System.Drawing.Point(8, 8);
			this.groupBoxServer.Name = "groupBoxServer";
			this.groupBoxServer.Size = new System.Drawing.Size(400, 56);
			this.groupBoxServer.TabIndex = 28;
			this.groupBoxServer.TabStop = false;
			this.groupBoxServer.Text = "T[oݒ";
			// 
			// groupBoxDebug
			// 
			this.groupBoxDebug.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.textBoxMessage,
																						this.checkBoxMessage});
			this.groupBoxDebug.Location = new System.Drawing.Point(8, 120);
			this.groupBoxDebug.Name = "groupBoxDebug";
			this.groupBoxDebug.Size = new System.Drawing.Size(400, 128);
			this.groupBoxDebug.TabIndex = 29;
			this.groupBoxDebug.TabStop = false;
			this.groupBoxDebug.Text = "fobO";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
			this.ClientSize = new System.Drawing.Size(426, 352);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.splitter1,
																		  this.groupBoxCommand,
																		  this.statusBar,
																		  this.tabControl});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "FelicaSimpleServer";
			this.tabControl.ResumeLayout(false);
			this.tabPageId.ResumeLayout(false);
			this.tabPageOption.ResumeLayout(false);
			this.groupBoxCommand.ResumeLayout(false);
			this.groupBoxSort.ResumeLayout(false);
			this.groupBoxRemove.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).EndInit();
			this.groupBoxServer.ResumeLayout(false);
			this.groupBoxDebug.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		#region GUIR|[lg̃Cxg
		//GUIR|[lg̏ԂύXD
		private void ChangeComponentState(Modes m)
		{
			mode = m;
			switch(mode)
			{
				case Modes.Init:
					buttonClose.Enabled = false;
					buttonOpen.Enabled = true;

					textBoxIp.Enabled = true;
					numericUpDownPort.Enabled = true;
					buttonIp.Enabled = true;
					tabControl.SelectedIndex = 1;
					break;

				case Modes.Open:
					buttonClose.Enabled = true;
					buttonOpen.Enabled = false;
					
					textBoxIp.Enabled = false;
					numericUpDownPort.Enabled = false;
					buttonIp.Enabled = false;

					tabControl.SelectedIndex = 0;

					break;
			}
			return;
		}
		
		private void buttonOpen_Click(object sender, System.EventArgs e)
		{
			StartServer();
			ChangeComponentState(Modes.Open);
			return;
		}

		private void buttonClose_Click(object sender, System.EventArgs e)
		{
			StopServer();
			ChangeComponentState(Modes.Init);
			return;
		}

		private void textBoxIp_Leave(object sender, System.EventArgs e)
		{
			try
			{
				if(server == null)
					return;

				string pre = server.ipAddress.ToString();
				server.ipAddress = IPAddress.Parse(textBoxIp.Text);
				if(server.ipAddress.ToString() != pre)
					Util.PrintMessage(true, "IP: {0}", server.ipAddress.ToString());
			}
			catch(Exception ex)
			{
				server.ipAddress = null;
				Util.PrintMessage(true, ex.ToString());
			}
		}

		private void numericUpDownPort_Leave(object sender, System.EventArgs e)
		{
			if(server ==null)
				return;

			int pre = server.port;
			server.port = int.Parse(numericUpDownPort.Text);
			if(server.port != pre)
				Util.PrintMessage(true, "Port: {0}", server.port);
		}

		private void numericUpDownPort_ValueChanged(object sender, System.EventArgs e)
		{
			if(server ==null)
				return;
			int pre = server.port;
			server.port = (int)numericUpDownPort.Value;
			if(server.port != pre)
				Util.PrintMessage(true, "Port: {0}", server.port);
		}

		private void checkBoxMessage_CheckedChanged(object sender, System.EventArgs e)
		{
			messageEnabled = checkBoxMessage.Checked;
		}

		private void radioButtonSortIp_CheckedChanged(object sender, System.EventArgs e)
		{
			if(radioButtonSortIp.Checked)
				listViewSort = ListViewSort.IpPort;
			else
				listViewSort = ListViewSort.Id;
		}

		private void radioButtonRemoveColor_CheckedChanged(object sender, System.EventArgs e)
		{
			if(radioButtonRemoveColor.Checked)
				listViewRemove = ListViewRemove.Color;
			else
				listViewRemove = ListViewRemove.Del;
		}
		
		private void buttonIp_Click(object sender, System.EventArgs e)
		{

			IPAddress ip =  GetCurrentIpAddress();
			textBoxIp.Text = ip.ToString();

			if(server == null)
				return;

			server.ipAddress = ip;
		}

		//Xe[^Xo[bZ[W̐ݒ
		public void SetStatusBar(string message)
		{
			this.statusMessage = message;
			this.statusBar.Invoke(new EventHandler(StatusBarMessageUpdate));

		}

		//fobOpbZ[Wݒ
		public void SetMessage(string message)
		{
			this.message = message;
			this.textBoxMessage.Invoke(new EventHandler(TextBoxMessageUpdate));
		}

		//UIR|[lg̍XV
		private void StatusBarMessageUpdate(object sender, EventArgs e)
		{
			lock(this)
			{
				this.statusBar.Text = this.statusMessage;
			}
			this.statusBar.Update();
		}

		//UIR|[lg̍XV
		private void TextBoxMessageUpdate(object sender, EventArgs e)
		{
			lock(this)
			{
				this.textBoxMessage.Text = this.message + "\r\n" + textBoxMessage.Text;
			}
			this.textBoxMessage.Update();
		}

		//Xgr[\pɃNCAg𐮌`
		public ListViewItem FormatListViewItem(ClientItem ci)
		{
			ListViewItem item = null;
			string []subItems = {ci.ip.ToString() + ":" + ci.port.ToString(),  
									ci.clientId.ToString(), ci.felicaId.ToString(), ci.date.ToString()};
			item = new ListViewItem(subItems);
			return item; 
		}
		
		//Xgr[NCAg폜
		public void RemoveListViewItem(ListViewItem item)
		{			
			int sortItemNo = 0;

			if(listViewSort == ListViewSort.Id)
				sortItemNo = 1;
			else
				sortItemNo = 0;

			foreach(ListViewItem li in listViewClient.Items)
			{
				if((string)li.SubItems[sortItemNo ].Text == item.SubItems[sortItemNo ].Text)
				{
					if(listViewRemove == ListViewRemove.Del)
						listViewClient.Items.Remove(li);
					else
						li.ForeColor = Color.Gray;
					break;
				}
			}
		}

		//ListViewɃNCAgǉ
		public void AddListViewItem(ListViewItem item)
		{
			bool existFlag = false;

			int sortItemNo = 0;

			if(listViewSort == ListViewSort.Id)
				sortItemNo = 1;
			else
				sortItemNo = 0;

			foreach(ListViewItem li in listViewClient.Items)
			{
				if((string)li.SubItems[sortItemNo].Text == item.SubItems[sortItemNo].Text)
				{
					existFlag = true;
					for(int i=0;i<li.SubItems.Count;i++)
					{
						li.SubItems[i].Text = item.SubItems[i].Text;
					}
					li.ForeColor = Color.Black;
					break;
				}
			}
			if(!existFlag)
			{
				listViewClient.Items.Add(item);
			}
		}
		#endregion

		#region Save/Load̏
		//ݒt@C̕ۑ
		private void SaveSettings()
		{
			StreamWriter fileStream = null;
			try
			{
				fileStream = new StreamWriter(settingFileName, false);
				fileStream.WriteLine(@"#Setting: ServerIP, ServerPort, MessageEnabled, ListViewSort, ListViewRemove");
				
				fileStream.WriteLine(String.Format("{0},{1},{2},{3},{4}", 
													server.ipAddress.ToString(), server.port,
													messageEnabled, 
													(int)listViewSort, (int)listViewRemove));
			}
			catch(IOException ex)
			{
				Util.PrintMessage(ex.ToString());
			}
			finally
			{
				if(fileStream != null)
				{
					fileStream.Close();
					fileStream = null;		
				}
			}
		}

		//ݒt@C̓ǂݏo
		private void LoadSettings()
		{
			StreamReader fileStream = null;
			string line;
			try
			{
				//t@CȂΏI
				if(!File.Exists(settingFileName))
					return;

				fileStream = new StreamReader(settingFileName);

				while(true)
				{
					string [] lineParams;
					line = fileStream.ReadLine();

					if(line == null)
						break;

					if(line.StartsWith(@"#"))
						continue;
					
					lineParams = line.Split(",".ToCharArray());

					if(lineParams.Length < 5)
						continue;					

					textBoxIp.Text = lineParams[0];
					numericUpDownPort.Value = int.Parse(lineParams[1]);
					messageEnabled = bool.Parse(lineParams[2]);
					listViewSort = (ListViewSort)int.Parse(lineParams[3]);
					listViewRemove = (ListViewRemove)int.Parse(lineParams[4]);

					if(server != null)
					{
						try
						{
							server.ipAddress = IPAddress.Parse(textBoxIp.Text);	
						}
						catch(Exception ex)
						{
							Util.PrintMessage(true, ex.Message);
						}
						server.port = (int)numericUpDownPort.Value;
					}
					checkBoxMessage.Checked = messageEnabled;
					if(listViewSort == ListViewSort.Id)
						radioButtonSortId.Checked = true;
					else
						radioButtonSortIp.Checked = true;

					if(listViewRemove == ListViewRemove.Color)
						radioButtonRemoveColor.Checked = true;
					else
						radioButtonRemoveDel.Checked = true;

					break;
				}
			}
			catch(IOException ex)
			{
				Util.PrintMessage(ex.ToString());
			}
			finally
			{
				if(fileStream != null)
				{
					fileStream.Close();
					fileStream = null;
				}
			}
		}
		#endregion

		#region lbg[N̏

		//T[o[D
		private bool InitServer()
		{
			IPAddress ip = null;
			int port = 0;
			try
			{
				string hostname = Dns.GetHostName();
				IPHostEntry ipHost = Dns.GetHostByName(hostname);
			
				ip = IPAddress.Parse(textBoxIp.Text);
				port = (int)numericUpDownPort.Value;
				server = new Server(this, ip, port);
				return true;
			}
			catch (Exception ex)
			{
				Util.PrintMessage(ex.ToString());
			}
			return false;
		}

		//T[o[JnD
		public bool StartServer()
		{
			if(server == null)
				return false;

			if(server.StartServer())
			{
				Util.PrintMessage(true, "T[oJn܂.");
				Util.PrintMessage("IP:{0}, Port:{1}", server.ipAddress.ToString(), server.port);
				return true;
			}
			else
			{
				Util.PrintMessage(true, "T[o̊JnɎs܂.");
				Util.PrintMessage(false, "IP:{0}, Port:{1}", server.ipAddress.ToString(), server.port);
				return false;
			}
		}

		//T[o[~D
		public bool StopServer()
		{
			if(server == null)
				return false;

			server.StopServer();
			Util.PrintMessage(true, "T[o~܂.");
			return true;
		}

		//݂̃Rs[^IP擾D
		private IPAddress GetCurrentIpAddress()
		{
			IPAddress ip = null;
			string hostname = Dns.GetHostName();
			IPHostEntry ipHost = Dns.GetHostByName(hostname);
			
			if(ipHost.AddressList.Length > 0)
			{
				ip = ipHost.AddressList[0];
			}
			return ip;
		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}
	}
}
