using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Collections;
using System.Text.RegularExpressions;
using System.IO;
using System.Windows.Forms;

namespace FelicaSimpleServer
{
	/// <summary>
	/// FelicaToNetƂ̒ʐMs
	/// </summary>
	public class Server
	{
		#region ϐ
		MainForm form;
		
		//NCAgƑM萔
		const string CommandAck = "ACKN";
		const string CommandDisconnect = "DCON";

		//lbgM̋؂蕶
		const string Delimiter = "\n";

		//\Pbgi[nbV
		private Hashtable socketHolder = new Hashtable();
		//Xbhi[nbV
		private Hashtable threadHolder = new Hashtable();
		
		private TcpListener tcpListener;
		
		//݂̐ڑNCAg̓FpID
		int connectId = 0;
		//ڑ\ȃNCAg̍ő吔
		//const int ConnectIdMax = 16;
		const int ClientNumMax = 16;
		//\PbgʐM̃obt@TCY
		const int NetworkBuffSize = 1024;
		//NCAgpXbh̓(msec)
		const int SocketSleepTime = 100;
		
		//T[oIPƃ|[g
		public IPAddress ipAddress = null;
		public int port = 0;
		//T[õI[vɐtrue
		public bool isOpen = false;
		#endregion

		#region RXgN^/fXgN^
		//RXgN^
		public Server(MainForm form, IPAddress ip, int p)
		{
			this.form = form;
			this.ipAddress  = ip;
			this.port = p;
		}
		//fXgN^
		public void Dispose()
		{
			CloseAllThreads();
			StopServer();
		}
		#endregion

		#region ڑt/Xbh֘A
		//Mҋ@Xbh
		public void WaitClient()
		{
			try
			{
				while(true)
				{
					//ڑҋ@
					Socket socket = tcpListener.AcceptSocket();
					
					if (connectId < ClientNumMax)
						Interlocked.Increment(ref connectId);//ϐւ̃ANZX𓯊
					else
						connectId = 1;
					
					//\Pbg̐ڑőlȉȂʐMJn
					if (socketHolder.Count < ClientNumMax )
					{
						while (socketHolder.Contains(connectId) )
						{
							Interlocked.Increment(ref connectId);
						}

						Thread thread = new Thread(new ThreadStart(Run));		
		
						lock(this)
						{
							//nbVɒǉ
							socketHolder.Add(connectId, socket);
							threadHolder.Add(connectId, thread);
						}
					
						thread.Start();	
						Thread.Sleep(SocketSleepTime);
					}
				} 
			}
			catch(SocketException e)
			{
			}
			catch(ThreadAbortException e)	//Thread.Abort
			{
			}
			catch(Exception e)
			{
				Util.PrintMessage(e.ToString());
			}
			this.StopServer();
		}

		//SXbh~
		public void CloseAllThreads()
		{
			try
			{
				if (tcpListener!=null)
				{
					tcpListener.Stop();
					tcpListener = null;
				}
				foreach (Socket s in socketHolder.Values) 
				{
					if(s.Connected)
					{
						//؂藣ꂽ`B
						SendNetDisconnect(s);
						s.Close();
					}
				}
				foreach (Thread t in threadHolder.Values) 
				{
					if(t.IsAlive)
						t.Abort();
				}
			}
			catch(Exception ex)
			{
			}
		}
		
		#endregion
		
		#region NCAg̎M
		//eNCAgƂ̒ʐMsXbh
		public void Run()
		{
			//ڑNCAg̓FpID
			int realId = connectId;

			Socket socket = (Socket)socketHolder[realId];
			ClientItem clientItem = null;
			
			//Mꎞi[ϐ
			string line ="";
			//M̒
			int rxLength = 0;

			try
			{
				IPAddress clientIp = ((IPEndPoint)socket.RemoteEndPoint).Address;
				int clientPort = ((IPEndPoint)socket.RemoteEndPoint).Port;

				Util.PrintMessage("NCAg:{0}[IP:{1},Port:{2}]", 
										realId, clientIp.ToString(),clientPort);
				clientItem = new ClientItem(clientIp, clientPort);
				while(true)
				{
					if(!socket.Connected)
						break;

					//Mobt@
					byte []rxBytes = new byte[NetworkBuffSize];
					//MoCg擾 
					rxLength =  socket.Receive(rxBytes,0,rxBytes.Length,SocketFlags.None);

					if(rxLength > 0)
					{
						//null폜
						rxBytes = Util.ChopBytes(rxBytes);
						//MoCg񂪋ȂĎM
						if(rxBytes == null)
							continue;

						//byte[]string^ɕϊ
						line = line + Util.ConvertBytesToStr(rxBytes,rxBytes.Length);
					
						Match m = Regex.Match(line, Delimiter);

						if(!m.Success)	
							continue;
						
						string [] texts = Regex.Split(line, Delimiter);
						
						//NCAg̃bZ[Wp[X
						for(int i= 0;i<texts.Length;i++)
						{
							if(i < texts.Length-1)
							{			
								ParseCommand(socket, texts[i], ref clientItem);
							}
							else
							{
								if(line.EndsWith(Delimiter))
								{
									ParseCommand(socket, texts[i], ref clientItem);
									line = "";
								}
								else
								{
									line = texts[i];
								}
							}
						}		
					}
					Thread.Sleep(SocketSleepTime);
				}
			}
			catch (SocketException e)
			{
			}
			catch (ThreadAbortException e)
			{	
			}
			catch (Exception e) 
			{	
				Util.PrintMessage(e.ToString());
			}
			finally
			{
				try
				{
					if(clientItem != null)
						form.RemoveListViewItem(form.FormatListViewItem(clientItem));
		
					if(socket == null || !socket.Connected)
					{
					}
					else
					{
						//T[o[_E`
						SendNetDisconnect(socket);
						socket.Close();
					}
					lock(this)
					{
						socketHolder.Remove(realId);
						threadHolder.Remove(realId);
					}
				}
				catch(Exception ex)
				{
				}	
			}
		}

		//R}h߂
		bool ParseCommand(Socket s, string line, ref ClientItem clientItem)
		{
			if(line.StartsWith(CommandDisconnect))
			{
				s.Close();
				Util.PrintMessage(CommandDisconnect);
				return true;
			}
			//ʏ̃bZ[WƂď
			else
			{
				ClientItem cItem = new ClientItem(clientItem.ip, clientItem.port,line);
				if(cItem.isReady)
				{
					clientItem = cItem;
					ListViewItem li = form.FormatListViewItem(clientItem);
					form.AddListViewItem(li);
					Util.PrintMessage(line);
					SendNetAck(s);
					return true;
				}
				else
				{
					return false;
				}
			}
		}
		#endregion
		
		#region NCAgւ̃R}hM
		//AckM
		private bool SendNetAck(Socket socket)
		{
			string message = "";

			message = CommandAck;
			SendNetMessage(socket, message);
			return true;
		}

		//NGM
		private bool SendNetDisconnect(Socket socket)
		{
			string message = "";

			message = CommandDisconnect;
			SendNetMessage(socket, message);
			return true;
		}
		
		//ۂ̑M
		private bool SendNetMessage(Socket socket, string message)
		{
			byte[] txBuff = null;

			if(socket.Connected)
			{
				txBuff = Util.ConvertStrToBytes(message + Regex.Unescape(Delimiter));
				txBuff = Util.ChopBytes(txBuff);
				socket.Send(txBuff, 0,txBuff.Length,SocketFlags.None);
				Util.PrintMessage("NCAgɑM[{0}]", message);
				return true;
			}
			return false;
		}

		#endregion

		#region T[o[̊Jn/~
		//T[o[N
		public bool StartServer()
		{
			try
			{
				if (tcpListener==null)
				{
					if(ipAddress!= null)
					{
						tcpListener= new TcpListener(ipAddress, port);
						tcpListener.Start();

						Thread t = new Thread(new ThreadStart(WaitClient));
						threadHolder.Add(0, t);
						t.Start() ;
						this.isOpen = true; 
					}
					else 
					{
						Util.PrintMessage("IPAhXłD");
						return false;
					}
				}
				else
				{	
					return false;
				}

			}
			catch(Exception ex)
			{
				Util.PrintMessage(ex.ToString());
				return false;
			}
			return true;
		}

		//T[o[~
		public void StopServer()
		{
			this.CloseAllThreads();
			
			try
			{
				connectId = 0;
				if(tcpListener != null)
				{
					tcpListener.Stop();
					tcpListener = null;
				}
				if(threadHolder != null)
				{
					threadHolder.Clear();
				}
			}
			catch(Exception e)
			{
				Util.PrintMessage(e.ToString());
			}

			this.isOpen = false; 
		}
		#endregion
	}
}
